;; linear combination explanation
;; by josh gentry

#include "asm86.h"
#include "ti86asm.inc"

         .org      _asm_exec_ram

         nop
         jp        startProg
         .dw       0
         .dw       progTitle
progTitle:
         .db       " Linear Combination Explanation",0

startProg:
         call      _clrLCD
         call      _runindicoff
         ld        hl,progTitle
         ld        bc,$0000
         call      vDisplay
         ld        hl,$FC00
         call      invert7
         ld        bc,$0700
         ld        (_penCol),bc
         ld        hl,pg1Txt
         call      dispArray
         call      _pause

         call      clrMost
         ld        bc,$0700
         ld        (_penCol),bc
         ld        hl,pg2Txt
         call      dispArray
         call      _pause

         call      clrMost
         ld        bc,$0700
         ld        (_penCol),bc
         ld        hl,pg3Txt
         call      dispArray
         call      _pause

         call      clrMost
         ld        bc,$0700
         ld        (_penCol),bc
         ld        hl,pg4Txt
         call      dispArray
         call      _pause

         jp        _clrScrn

;;;;;;;;;;;;;;
;; routines ;;
;;;;;;;;;;;;;;
vDisplay:
         ld        (_penCol),bc
         jp        _vputs

invert7: ld        b,7*16    ;; 7 rows, 16 bytes per row
invLoop: ld        b,16
         ld        a,(hl)
         cpl
         ld        (hl),a
         inc       hl
         djnz      invLoop
         ret

dispArray:
         ld        b,(hl)
         inc       hl
dALoop:  call      _vputs
         ld        a,(_penRow)
         add       a,6
         ld        (_penRow),a
         sub       a
         ld        (_penCol),a
         djnz      dALoop
         ret

clrMost: ld        hl,$FC00+(7*16)
         ld        (hl),$00
         ld        de,($FC00+(7*16))+1
         ld        bc,1024-(7*16)
         ldir
         ret

;;;;;;;;;;
;; data ;;
;;;;;;;;;;
pg1Txt:  .db       $09
         .db       "Solve equations by Linear Combination",0
         .db       "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~",0
         .db       "1) Arrange like variables above each",0
         .db       "other.",0
         .db       "2) Multiply each equation OR one",0
         .db       "equation by an appropriate number so",0
         .db       "that the coefficients of one variable",0
         .db       "are opposites.",0
         .db       "Press [ENTER] to continue...",0
pg2Txt:  .db       $09
         .db       "3) Add the two equations so that one",0
         .db       "variable cancels out, solve for the",0
         .db       "remaining variable.",0
         .db       "4) Substitute the answer in step 3 into",0
         .db       "the matching variable in one of the",0
         .db       "original equations to solve for the",0
         .db       "other variable.",0
         .db       " ",0
         .db       "Press [ENTER] for an example...",0
pg3Txt:  .db       $09
         .db       "Example:",0
         .db       "  8x  + 2y = 26",0
         .db       "+ 10x - 2y = 28",0
         .db       "~~~~~~~~~~~~~~~",0
         .db       "  18x = 54",0
         .db       " /18    /18",0
         .db       "~~~~~~~~~~~",0
         .db       " x = 3",0
         .db       "Press [ENTER] for more...",0
pg4Txt:  .db       $09
         .db       "Now to get 'y':",0
         .db       "  8x  + 2y = 26",0
         .db       "  8(3)+ 2y = 26",0
         .db       "  24  + 2y = 26",0
         .db       " -24        -24",0
         .db       "~~~~~~~~~~~~~~~",0
         .db       "  2y = 2",0
         .db       "  /2   /2",0
         .db       "  y = 1",0

.end
END

Solving Systems of equations by Linear Combination
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

1) Arrange like variables above each other.

2) Multiply each equation OR one equation by an appropriate number such
that the coefficients of one variable are opposites.

3) Add the two equations so that one variable cancels out, solve for the
remaining variable.

4) Substitute the answer in step 3 into the matching variable in one of the
original equations to solve for the other variable.

Example:

  8x  + 2y = 26
+ 10x - 2y = 28
~~~~~~~~~~~~~~~
  18x = 54
 /18  | /18
~~~~~~~~~~~
 x = 3

Now to get 'y':
  8x  + 2y = 26
  8(3)+ 2y = 26
  24  + 2y = 26
 -24        -24
~~~~~~~~~~~~~~~
  2y = 2
  /2   /2
~~~~~~~~~
  y = 1